/*
 * 作成日: 2005/02/17
 *
 * TODO この生成されたファイルのテンプレートを変更するには次へジャンプ:
 * ウィンドウ - 設定 - Java - コード・スタイル - コード・テンプレート
 */
package jp.co.ntt.lms.xmf.actions.xmo.GroupAndPeople;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import jp.co.ntt.lms.xmo.Groups.GroupsClient;

import org.apache.struts.action.Action;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;
import org.apache.struts.util.MessageResources;

/**
 * @author Administrator
 *
 * TODO この生成された型コメントのテンプレートを変更するには次へジャンプ:
 * ウィンドウ - 設定 - Java - コード・スタイル - コード・テンプレート
 */
public class GroupAndPeopleFrame_SendAction extends Action {

	/* (非 Javadoc)
	 * @see org.apache.struts.action.Action#execute(org.apache.struts.action.ActionMapping, org.apache.struts.action.ActionForm, javax.servlet.http.HttpServletRequest, javax.servlet.http.HttpServletResponse)
	 */
	public ActionForward execute(ActionMapping map, ActionForm form,
			HttpServletRequest request, HttpServletResponse response) throws Exception {

		// メッセージリソース取得
		MessageResources msgResources = getResources(request, "msg.xmf.xmo.GroupAndPeople.GroupAndPeopleMessage");

		String strGroupRootName_o = "";						//グループルート名

		String strLoginUserID = (String)request.getSession().getAttribute(msgResources.getMessage("USER_ID"));

		// ログインユーザがスーパーユーザか普通の管理者かでルートのIDを切り分けます。
		String strTreeRoot_o = null;
		if( strLoginUserID == null ) {
			// セッションが切れている場合はログイン画面にリダイレクト
			return map.findForward("loginRedirect");
		}
		else {
			// ログインユーザがスーパーユーザの場合
			if( strLoginUserID.equals(msgResources.getMessage("SUPER_USER")) ) {
				strTreeRoot_o = msgResources.getMessage("GROUP_ROOT_o");
				//////////////////////////////////////////////////
				//グループのルート名ををデータベースから取得する。
				//////////////////////////////////////////////////
				GroupsClient objGroups = new GroupsClient();
				// 検索条件の設定
				objGroups.setWhereGroupID( msgResources.getMessage("GROUP_ROOT_o") );
				if( !objGroups.select() ) {
					// 検索がうまくいかなかった場合
					if( objGroups.isErr() ) {
						// エラーの場合
						request.setAttribute("MessageData", objGroups.getMessageData());
						return map.findForward("error");
					}
					else {
						String strMessage =  objGroups.getMessage();
						return getParamErrForward(map, request, strMessage, null, true );
					}
				}

				// グループ名の取得
				if( objGroups.next() ) {
					strGroupRootName_o = objGroups.getGroupName();
				}
				else {
					//グループ名が存在しない場合エラーを出力する
					String strMessage =  "グループ名が存在しません。";
					return getParamErrForward(map, request, strMessage, null, true );
				}

			}
			else {
				strTreeRoot_o = msgResources.getMessage("GROUP_TREE_ROOT");
				strGroupRootName_o = msgResources.getMessage("TREE_ROOT_NAME");
			}
			
		}

		// ホスト情報の取得
		String strServerName_o = request.getServerName();
		int intServerPort_o = request.getServerPort();
		String strContextPath_o = request.getContextPath();
		String strTdID_o = "SelectedTargetID/"+strTreeRoot_o;//Rootのラベルの識別ID

		
		// 表示用データを格納
		request.setAttribute("strTreeRoot_o", strTreeRoot_o);
		request.setAttribute("strTdID_o", strTdID_o);
		request.setAttribute("strServerName_o", strServerName_o);
		request.setAttribute("intServerPort_o", new Integer(intServerPort_o));
		request.setAttribute("strContextPath_o", strContextPath_o);
		
		return map.findForward("success");
	}

	private ActionForward getParamErrForward(ActionMapping map, HttpServletRequest request, String strMessage, String strDetail, boolean isClose){
		request.setAttribute("message", strMessage);
		request.setAttribute("detail", strDetail);
		if( isClose ) {
			request.setAttribute("close", "on");
		}
		return map.findForward("paramError");
	}
}
